Subject: Re: [PATCH net-next] eth: mtk_eth_soc: silence the GCC 12 array-bounds warning

From: Jakub Kicinski <[email-masked]>
Date: Fri, 20 May 2022 09:43:21 -0700

On Fri, 20 May 2022 15:06:52 +0200 Andrew Lunn wrote:
> On Thu, May 19, 2022 at 10:59:40PM -0700, Jakub Kicinski wrote:
> > GCC 12 gets upset because in mtk_foe_entry_commit_subflow()
> > this driver allocates a partial structure. The writes are
> > within bounds.  
> 
> I'm wondering if the partial structure is worth it:
> 
> struct mtk_flow_entry {
>         union {
>                 struct hlist_node list;
>                 struct {
>                         struct rhash_head l2_node;
>                         struct hlist_head l2_flows;
>                 };
>         };
>         u8 type;
>         s8 wed_index;
>         u16 hash;
>         union {
>                 struct mtk_foe_entry data;
>                 struct {
>                         struct mtk_flow_entry *base_flow;
>                         struct hlist_node list;
>                         struct {} end;
>                 } l2_data;
>         };
>         struct rhash_head node;
>         unsigned long cookie;
> };
> 
> 
> It allocates upto l2_data.end
> 
> struct rhash contains a single pointer
> 
> So this is saving 8 or 16 bytes depending on architecture.
> 
> I estimate the structure as a whole is at least 100 bytes on 32bit
> systems.
> 
> I suppose it might make sense if this makes the allocation go from 129
> bytes to <= 128, and the allocater is rounding up to the nearest power
> of 2?

Good point, I'm not sure what Felix prefers. I think isolating the
necessary fields into a different structure and encapsulating that
into something with the extra two members (or maybe the GROUP_MEMBER
macro thing?) would be another way forward.

I'd still like explicit feedback on the Makefile hack. Is it too ugly?
We could wait for GCC 12 to get its act together was well, but 
I'm guessing Dave and I are not the only people who will upgrade to
Fedora 36 and enter a world of pain...